code    segment byte    public  'CODE'
        assume  cs:code,ds:code
;        org     100h

.xlist
;include MSDOS.INC
include PRM17.INC
;include PRM17.INC
include USER.INC

cleanbuf macro
        mov     byte ptr strsize,0
endm

cleanpos  macro
        cleanbuf
        mov     byte ptr strpos,0
endm

.list

chatID  equ     87h
maxfun  equ     2
cr      equ     0dh
lf      equ     0ah
yON     equ     -1
yOFF    equ     -2
sysop   equ     14              ; yellow
caller  equ     3               ; cyan

start:  jmp     near ptr $init

hello   db      cr,lf,'Opus chat and yell Fossil module, v. 0.01',cr
        db      'Copyright (C) 1988 George A. Stanislav. All Rights Reserved.'
        db      cr,lf,0,26
unknown db      'Don''t understand this function call request.',7,cr,0
version db      'Can''t deal with this .PRM version.',7,cr,0
chatB   db      cr,lf,'CHAT starts:',cr,lf,0
chatE   db      cr,lf,'CHAT ends.',0
cHELP   db      'SYSOP: Press Alt-Q to quit chat.',cr,lf,0
yHELP   db      cr,lf,'SYSOP: Press ''C'' to start chatting.',cr,lf,0
paging  db      ' paging Sysop ',0
no_ans  db      cr,lf,lf,'There is no answer.',0
no_page db      cr,lf,lf,'Paging not available at this time.',0
hole    db      cr,lf,'Caller vanished in a black hole!',cr,lf,7,0
engaged db      cr,lf,'Sysop engaged in chat on another port.',lf
eng2    db      cr,'Please try later or leave a message.'
enter   db      cr,'Press ENTER to continue.'
enlen   equ     $-engaged
        db      0
o_msg1  db      cr,lf,'YELL override: forced ON.',cr,lf,0
o_msg2  db      cr,lf,'YELL override: forced OFF.',cr,lf,0
o_msg3  db      cr,lf,'YELL override: none (follows Y events).'
        db      cr,lf,0
cleanup db      ' ',0
;oldtimer dd     0
busy    db      0
comment *
com_port dw     0
car_mask dw     0
user    dw      0
beeps   dw      0
*
speed   dw      5
yTYPE   dw      0
yFLAG   dw      -3              ; init with no override
function dw     offset $chat
        dw      offset $yell
        dw      offset $setup
o_msg   dw      offset  o_msg1
        dw      offset  o_msg2
        dw      offset  o_msg3
avstr   db      '',0          ; AVATAR string
ansi    db      '['
ansl    db      '1;3'           ; ANSI string
ansc    db      '7;40m',0
;tflag   db      1
;timer   db      0
;delay   db      0

com_port equ    [bp-2]
car_mask equ    [bp-4]
user    equ     [bp-6]
beeps   equ     [bp-8]
color   equ     [bp-10]         ; Sysop or caller chatting
video   equ     [bp-11]         ; Is it IBM?
scrlen  equ     [bp-12]         ; User's screen width - 5
strsize equ     [bp-13]         ; Size of last string typed and saved in buffer
strpos  equ     [bp-14]
buffer  equ     [bp-94]         ; Bottom of buffer
vPage   equ     [bp-95]
oldpage equ     [bp-96]
row     equ     [bp-97]
column  equ     [bp-98]
uvideo  equ     [bp-100]
stacksize equ   102
reg_AX  equ     [bp+2]
reg_DX  equ     [bp+4]
reg_CX  equ     [bp+14]

$entry  proc    FAR
        push    bx
        push    cx
        push    ds
        push    si
        push    es
        push    di
        push    dx
        push    ax
        push    bp
        mov     bp,sp
        sub     sp,stacksize

        mov     byte ptr strsize,0
        mov     byte ptr strpos,0
        mov     byte ptr scrlen,75

        push    si
        push    ax
        mov     ax,cs
        mov     ds,ax

        xor     al,al
        mov     byte ptr video,al       ; default to no IBM

        mov     ax,es:[di].USER_bits
        and     ax,CURSOR_CONTROL
        mov     uvideo,ax

        mov     al,sysop + 1
        call    $color

        xor     ax,ax                   ; Assume we return a 0
        mov     reg_AX,ax
        mov     reg_DX,ax

        cmp     cx,0                    ; Paging turned off?
        jng     $b3
$b0:    cmp     cx,5                    ; How long should we beep?
        jng     $b1
        cmp     cx,255
        jb      $b2

$b1:    mov     cx,30
$b2:    shl     cx,1
$b3:    mov     beeps,cx

        mov     si,offset hello
        call    message

        pop     ax
        cmp     al,maxfun
        jna     $begin
        mov     dx,offset unknown
$bad:   mov     si,dx
        call    message 
        mov     ax,1
        mov     reg_AX,ax
        jmp     short $back

$begin: cbw
        mov     bx,ax
        shl     bx,1
        mov     dx,offset version       ; Invalid .PRM version
        pop     si
        mov     al,es:[si]
;        cmp     al,16
        cmp     al,17                  ; New PRM file
        jne     $bad
        mov     ax,es:[si].PRM_ComPort
        mov     com_port,ax
        mov     ax,es:[si].PRM_CarrierMask
        mov     car_mask,ax
        mov     al,es:[si].PRM_Video
        cmp     al,2
        jne     $vIBMnope
        or      bx,bx           ; are we here for chat?
        jne     $vIBMnope       ; no, don't bother with video
        mov     ah,0fh          ; get video mode
        int     10h
        mov     byte ptr oldpage,bh
        xor     bx,bx           ; chat function
        cmp     al,7            ; monochrome?
        jnb     $vIBMnope       ; yeah, don't do colors
        call    $home
        mov     al,3            ; use page 3
        push    ax
        call    $setpage
        pop     ax
        mov     byte ptr vPage,al
$vIBM:  mov     byte ptr video,al
$vIBMnope: mov  ax,di
        mov     user,ax
        call    word ptr function[bx]

        mov     ah,08h          ; Flush output buffer
        mov     dx,com_port
        int     14h

        mov     al,byte ptr video
        or      al,al
        je      $back
        mov     al,byte ptr oldpage
        call    $setpage

$back:  mov     sp,bp
        pop     bp
        pop     ax
        pop     dx
        pop     di
        pop     es
        pop     si
        pop     ds
        pop     cx
        pop     bx
        ret
$entry  endp

$setup  proc    near

        mov     ax,reg_CX
        mov     speed,ax
        mov     yTYPE,bx
        ret

$setup  endp

$setpage proc   near

        push    bx

        push    ax
        mov     ah,5            ; page is already in al
        int     10h
        pop     ax
        cmp     al,3
        jne     $setpE

        mov     ax,0600h        ; clear screen
        xor     cx,cx
        mov     dx,184fh
        mov     bh,15
        int     10h

$setpE: pop     bx
        ret

$setpage endp

$delay  proc    near

comment *
        mov     ax,1601h
        push    es
        push    cs
        pop     es
        mov     dx,offset $timer
        int     14h             ; Insert $timer in timer interrupt
        inc     ax              ; Faster and tighter than cmp ax,-1
        je      $d1             ; Unsuccessful, must fake with a loop
        xor     al,al
        mov     byte ptr timer,al
        mov     al,delay
$dLOOP: cmp     al,byte ptr timer       ; Let's see if enough ticks passed
        jna     $dLOOP
        mov     ax,1600h
        mov     dx,offset $timer
        int     14h             ; Remove from chain

$dE:    pop     es
        ret
*

$d1:    mov     cx,word ptr speed
$d2:    push    cx
        mov     cx,28010
$d3:    loop    $d3
        pop     cx
        loop    $d2

        ret
;        jmp     short $dE

$delay  endp

$home   proc    near

        push    bx

        mov     bh,3
        xor     dx,dx
        mov     ah,2
        int     10h

        pop     bx
        ret

$home   endp

$xmit   proc    near

        push    bx
        push    si
$xmitB: mov     si,ax
        call    putchar

$c3:    mov     ax,si
        call    sendchar
comment *
        mov     dx,com_port
        mov     ah,0bh
        int     14h
        or      ax,ax           ; Did we get through?
        je      $c3             ; No, try again

        mov     ax,si
        cmp     al,cr
        jne     $xmitE
        mov     al,lf
        jmp     short $xmitB
*
$xmitE: pop     si
        pop     bx
        ret

$xmit   endp


$chat   proc    near

        mov     al,1
        mov     busy,al         ; Disable paging
        mov     si,offset chatB
        call    say_it
        mov     si,offset cHELP
        call    message

        ; --- Chat
$cLOOP: mov     ah,0dh          ; read keyboard
        int     14h
        cmp     ax,-1
        je      $c1
        cmp     byte ptr color,sysop
        je      $cSYSOP
        mov     al,sysop
        call    $color
$cSYSOP: mov    ah,0eh
        int     14h
        or      al,al
        jne     $cXMIT
        cmp     ah,10h          ; alt-Q
        je      $cRETURN
        mov     al,7
        call    putchar

$c1:    mov     ah,0ch
        mov     dx,com_port
        int     14h
        cmp     ax,-1
        je      $c2

        cmp     byte ptr color,caller
        je      $cUSER
        mov     al,caller
        call    $color
$cUSER: mov     ah,2
        mov     dx,com_port
        int     14h
        jmp     short $cXMIT

$c2:    call    mCHECK
        or      ax,ax
        je      $cLOOP

$cRETURN: 
        mov     al,sysop + 1
        call    $color
        mov     si,offset chatE
        call    say_it
        call    $enter
        xor     al,al
        mov     busy,al                 ; Reenable paging
        ret

$cXMIT: cmp     al,8
        je      $cBS
        cmp     al,cr
        jne     $cX2
        cleanpos
$cX1:   call    $xmit
        jmp     short $cLOOP
$cBS:   cmp     byte ptr strpos,0
        je      $cBS2
        mov     si,offset cleanup
        call    say_it
        dec     byte ptr strpos
$cBS2:  cmp     byte ptr strsize,0
        je      $cX_
        dec     byte ptr strsize
$cX_:   jmp     $cLOOP
$cX2:   cmp     al,7            ; bell
        je      $cX1
        cmp     al,9            ; tab
        jne     $cX3
        mov     al,' '
        jmp     short $cX4
$cX3:   cmp     al,' '
        jb      $cX_            ; junk, skip it
        jne     $cX5
$cX4:   cleanbuf
        call    $xmit
        xor     bx,bx
        jmp     short $cX6
$cX5:   ; add to the buffer
        call    $xmit
        xor     bx,bx
        mov     bl,byte ptr strsize     ; append to buffer
        mov     di,bx
        mov     byte ptr buffer[di],al
        inc     byte ptr strsize
$cX6:   inc     byte ptr strpos
        mov     bl,byte ptr strpos
        cmp     bl,byte ptr scrlen
        jna     add2
        mov     bl,byte ptr strsize
        cmp     bl,byte ptr scrlen
        jna     add1
$aCR_:  cleanpos                ; string too long - cut it.
        mov     al,cr
        call    $xmit
        jmp     $cLOOP
add1:   mov     cx,bx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; This is a dangerous place. If CX == 0, it takes so long that it appears
;; to lock up the system. Therefore, check it!
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
        or      cx,cx
        je      $aCR_           ; just go to next line
aLOOP:  mov     si,offset cleanup
        call    say_it
        loop    aLOOP
        mov     cx,bx
        xor     bx,bx
        mov     di,bx
        mov     al,cr
        call    $xmit
aLP:    mov     al,byte ptr buffer[di]
        call    $xmit
        inc     di
        loop    aLP
        mov     bx,di
        mov     byte ptr strpos,bl
        mov     byte ptr strsize,bl
add2:
        jmp     $cLOOP

$chat   endp

$enter  proc    near

        mov     si,offset enter
        call    say_it
        ret

$enter  endp

$color  proc    near

        push    bx
        push    si

        mov     color,al
        mov     bx,uvideo
        test    bx,USE_AVATAR
        jz      $hue0
        mov     si,offset avstr
        call    send_it
        call    sendchar
        jmp     short $hue4

$hue0:  test    bx,USE_ANSI
        jz      $hue4
        cmp     al,3            ; cyan?
        jne     $hue1
        mov     ansl,'0'
        mov     ansc,'6'
        jmp     short $hue3
$hue1:  mov     ansl,'1'
        cmp     al,sysop
        jne     $hue2
        mov     ansc,'3'                ; yellow
        jmp     short $hue3
$hue2:  mov     ansc,'7'                ; white
$hue3:  mov     si,offset ansi
        test    bx,USE_ANSI
        jz      $hue4
        call    send_it
$hue4:

        pop     si
        pop     bx
        ret

$color  endp

$yell   proc    near

        mov     ax,beeps
        mov     bx,word ptr yFLAG
        cmp     ax,0                    ; Is yell off?
        jne     $yBEG

; YELL was called with CX = 0, check for override:
        
        cmp     bx,yON
        je      $y2
$yOFF:  mov     si,offset no_page
        call    say_it
        mov     si,offset eng2
        call    say_it
        ret

$yBEG:  jg      $y1                     ; flags still reflect cmp ax,0
        call    $over
        ret

; YELL called with a positive integer in CX, check for override

$y1:    cmp     bx,yOFF
        je      $yOFF

$y2:    mov     al,byte ptr busy
        or      al,al
        je      $yellB
        mov     dx,com_port
        push    es
        push    ds
        pop     es
        mov     di,offset engaged
        mov     cx,enlen
        mov     ah,19h
        int     14h
        pop     es
        ret

$yellB: mov     si,offset yHELP
        call    message
        mov     si,word ptr user
        push    ds
        push    es
        pop     ds              ; User name is in extra segment!
        call    say_it
        pop     ds
        mov     si,offset paging
        call    say_it

        mov     cx,beeps
$yLOOP: push    cx
        mov     al,7
        call    $xmit
        mov     al,'.'
        call    $xmit
        mov     al,' '
        call    $xmit
        call    $delay                  ; half-a-sec
        call    mCHECK
        or      ax,ax
        jne     yERR                    ; Lost caller
        mov     ah,0dh
        int     14h
        cmp     ax,-1
        jne     ySYSOP                  ; Sysop answered
        pop     cx
        loop    $yLOOP
        mov     si,offset no_ans
        call    say_it
        call    $enter
        ret

yERR:
ySYSOP: pop     cx
        ret

$yell   endp

mCHECK  proc    near

        mov     ah,3
        mov     dx,com_port
        int     14h
        test    ax,car_mask             ; ax = 0 if carrier
        je      $hole
        xor     ax,ax
        ret

$hole:  mov     si,offset hole
        call    message
        mov     ax,1
        ret

mCHECK  endp

$over   proc    near            ; Set/reset or check yell override

        cmp     ax,-4           ; are we checking?
        jna     $ov1
        mov     word ptr yFLAG,ax       ; set, reset, whatever...
$ovE:   neg     ax
        dec     ax
        mov     bx,ax
        shl     bx,1
        mov     si,word ptr o_msg[bx]
$ovF:   call    message
        ret

$ov1:   jb      $ov2            ; unsupported function
        mov     ax,-1
        mov     reg_DX,ax
        mov     ax,word ptr yFLAG
        mov     reg_AX,ax
        jmp     short $ovE

$ov2:   mov     ax,1
        mov     reg_AX,ax
        mov     dx,offset unknown
        jmp     short $ovF

$over   endp
        

say_it  proc    near

        push    cx
        push    ax
        cld
$sB:    lodsb
        or      al,al
        je      $sE
        call    $xmit
        jmp     short $sB

$sE:    pop     ax
        pop     cx
        ret

say_it  endp

message proc    near

        cld
$msgB:  lodsb
        or      al,al
        je      $msgE
        call    putchar
        jmp     short $msgB

$msgE:  ret

message endp

send_it proc    near

        push    ax

        cld
$sdtB:  lodsb
        or      al,al
        je      $sdtE
        call    sendchar
        jmp     short $sdtB

$sdtE:  pop     ax
        ret

send_it endp

putchar proc    near

        push    cx
        push    si

$pcB:   mov     si,ax
        cmp     al,' '
        jb      $pc2            ; no attributes for bells and cr's
        mov     al,byte ptr video
        or      al,al
        je      $pc1            ; not IBM
        mov     ax,si
        mov     ah,9
        mov     bh,byte ptr vPage
        mov     bl,byte ptr color
        mov     cx,1
        int     10h
$pc1:   mov     ax,si
$pc2:   mov     ah,15h
        int     14h

        mov     ax,si
        cmp     al,cr
        jne     $pcE
        mov     al,lf
        jmp     short $pcB

$pcE:   pop     si
        pop     cx

        ret

putchar endp

sendchar proc   near

        push    ax

$scB:   push    ax
        mov     dx,com_port
        mov     ah,0bh
        int     14h
        or      ax,ax           ; Did we get through?
        pop     ax
        je      $scB            ; No, try again

        cmp     al,cr
        jne     $scE
        mov     al,lf
        jmp     short $scB

$scE:   pop     ax
        ret

sendchar endp


comment *
$timer  proc    FAR

        inc     byte ptr timer
        ret

$timer  endp
*

$INIT:  mov     ax,cs
        add     ax,10h
        mov     ds,ax


        mov     si,offset hello
        call    $message

        mov     ax,3514h
        int     21h
        cmp     word ptr es:[bx+6],1954h
        jne     $no_FOS

        mov     ax,ds
        mov     es,ax
        mov     ax,(7e00h+chatID)
        mov     dx,offset $entry
        int     14h
        cmp     ax,1954h
        jne     $old_FOS
        or      bh,bh
        je      $denied
        cmp     bl,chatID
        jne     $hmmm

comment *
        mov     ah,7
        int     14h
        shr     ah,1
        mov     byte ptr delay,ah       ; timer ticks per half second
*
        call    cmdline

        mov     si,offset done
        call    $message

        mov     dx,(offset $INIT) + 100h
        mov     cl,4
        shr     dx,cl
        inc     dx
        mov     ax,3100h
        int     21h

$no_FOS: mov     si,offset no_FOS
$bah:   call    $message
        mov     si,offset nosir
        call    $message
        mov     ax,4c01h
        int     21h

$old_FOS: mov   si,offset old_FOS
        jmp     short $bah              ; humbug!

$denied: mov    si,offset denied
        jmp     short $bah

$hmmm:  mov     si,offset hmmm
        jmp     short $bah

cmdline proc  near

seg1    equ     [bp-2]
sNumber equ     [bp-4]                  ; speed number

        push    bp
        mov     bp,sp
        sub     sp,6

        mov     ax,80h
        mov     si,ax                   ; command line
        mov     ax,ds
        mov     seg1,ax
        sub     ax,10h
        mov     ds,ax
        mov     es,ax
        mov     word ptr sNumber,0
        cld
        lodsb
        cbw
        or      ax,ax
        jz      $iE                     ; no command line
        mov     cx,ax                   ; number of command line chars
$iLOOP: lodsb
        cmp     al,'1'                  ; so we don't end up with a 0
        jb      $i1
        cmp     al,'9'
        jna      $i2
$i1:    loop    $iLOOP
        jmp     short $iE               ; no digits found

$i2:    push    si

$digit: mov     dx,10
        sub     al,'0'
        cbw
        push    ax
        mov     ax,sNumber
        mul     dx                      ; DX AX = sNumber * 10
        pop     dx
        jc      $cmdOVER                ; overflow
        add     ax,dx
        jc      $cmdOVER
        mov     sNumber,ax
        lodsb
        cmp     al,'0'
        jb      $gotCMD
        cmp     al,'9'
        ja      $gotCMD
        loop    $digit

$gotCMD: mov    ax,si
        dec     ax
        mov     di,ax
        xor     ax,ax
        stosb
        push    ds
        mov     ax,seg1
        mov     ds,ax
        mov     ax,sNumber
        mov     speed,ax
        mov     si,offset gotCMD
        call    $message
        pop     ds
        pop     si
        dec     si
        call    $message
        mov     ax,seg1
        mov     ds,ax
        mov     si,offset dot
        call    $message

$iE:    mov     ax,seg1
        mov     ds,ax
        mov     es,ax
        mov     sp,bp
        pop     bp
        ret

$cmdOVER:
        mov     ax,si
        mov     di,ax
        xor     ax,ax
        stosb
        push    ds
        mov     si,offset badCMD1
        mov     ax,seg1
        mov     ds,ax
        call    $message
        pop     ds
        pop     si
        dec     si
        call    $message
        mov     ax,seg1
        mov     ds,ax
        mov     si,offset badCMD2
        call    $message
        jmp     $iE

cmdline endp

$message proc   near

        push    si

        cld
$imL:   lodsb
        or      al,al
        je      $imE
$im1:   mov     dl,al
        mov     ah,2
        push    ax
        int     21h
        pop     ax
        cmp     al,cr
        jne     $imL
        mov     al,lf
        jmp     $im1

$imE:   pop     si

        ret

$message endp

done    db      cr,lf,'Both CHAT and YELL installed.',cr,0
nosir   db      ' (Chat and Yell NOT installed).',7,cr,lf,0
no_FOS  db      'No FOSSIL',0
comment *
noIBM   db      cr,lf,'For better performance on IBM compatibles use the -I'
        db      ' command line parameter.',0
*
old_FOS db      'FOSSIL: Need newer version',0
denied  db      'FOSSIL: Access denied',0
hmmm    db      'FOSSIL: hmmm...',0
gotCMD  db      'Using speed factor ',0
badCMD1 db      'Ignoring invalid speed factor: ',0
badCMD2 db      '. (Must be between 1-65535)'
dot     db      '.',cr,0

code    ends
end     start

