THIS_CTL_VERSION  equ 17       ; PRM structure version number
M_SNOOP           equ  1       ; Sysop display on


         ;
         ;--- Fidonet address structure
         ;
_ADDRESS STRUC
         ADDR_Zone         dw ?
         ADDR_Net          dw ?
         ADDR_Node         dw ?
         ADDR_Point        dw ?
_ADDRESS Ends


         ;
         ;--- ParmFile user class information
         ;
_uCLASS  STRUC
         Class_Priv        db ?
         Class_Fill        db ?
         Class_MaxTime     dw ?     ; max cume time per day
         Class_MaxCall     dw ?     ; max time for one call
         Class_MaxDL       dw ?     ; max dl bytes per day
         Class_Ratio       dw ?     ; ul:dl ratio
         Class_MinBaud     dw ?     ; speed needed for logon
         Class_MinDLBaud   dw ?     ; speed needed for file xfer
_uCLASS  EndS


         ;
         ;--- ParmFile information on what to pass to FOSSIL for `userexits'
         ;
_FOSREGS STRUC
         FOS_ax            dw ?
         FOS_bx            dw ?
         FOS_cx            dw ?
         FOS_dx            dw ?
_FOSREGS EndS


         ;
         ;--- Structure stored in .PRM file, version 16
         ;
_PRM     STRUC
         PRM_Version       db ?
         PRM_TaskNum       db ?
         PRM_Alias         db (15*type _ADDRESS) DUP(?)
         PRM_Video         db ?     ; 0=Dos, 1=Fossil 2=IBM
         PRM_Testmode      db ?     ; input from keyboard, not modem

         PRM_CarrierMask   dw ?
         PRM_Handshake     dw ?     ; Modem's handshake mask
         PRM_MaxBaud       dw ?     ; fastest speed we can use
         PRM_ComPort       dw ?     ; Com1=0, Com2=1, FF=keyboard

         PRM_MultiTasker   db ?     ; See OPUS.H
         PRM_Fill1         db ?

         PRM_ModemFlag     db ?     ; See OPUS.H
         PRM_LogFlag       db ?     ; See OPUS.H

         PRM_StyleFlag     db ?     ; See OPUS.H
         PRM_FWDFlag       db ?     ; See OPUS.H

         PRM_Flags         db ?     ; See OPUS.H
         PRM_Flags2        db ?     ; See OPUS.H

         PRM_EditExit      db ?     ; ERRORLEVEL to use if Matrix area changed
         PRM_ExitVal       db ?     ; ERRORLEVEL to use after caller
         PRM_InboundExit   db ?     ; ERRORLEVEL to use after inbound traffic
         PRM_LZWExit       db ?     ; ERRORLEVEL to use after inbound arcmail
         PRM_EchoExit      db ?     ; ERRORLEVEL to use after inbound echomail
         PRM_Fill2         db ?

         PRM_MinBaud       dw ?     ; minimum baud to get on-line
         PRM_VideoBaud     dw ?     ; minimum baud to use NON-TTY Video
         PRM_DateStyle     dw ?     ; Used for FILES.BBS display

         PRM_LogonPriv     db ?     ; Access level for new users
         PRM_SeenbyPriv    db ?     ; Min priv to see SEEN_BY line
         PRM_CtlAPriv      db ?     ; Priv to see CONTROL-A lines in messages
         PRM_FromFilePriv  db ?     ; Priv. for doing message from file

         PRM_AskPrivs      db 16 DUP(?)      ; Priv array for msg attr ask's
         PRM_AssumePrivs   db 16 DUP(?)      ; Priv array for msg attr assume's

         PRM_LogonTime     dw ?     ; Ask Bob Klahn (150/1)
         PRM_MatrixMask    dw ?     ; Z-Window matrix behavior mask

         PRM_NetBaud       dw ?     ; Min. baud rate for remote netmail
         PRM_MaxJanusBaud  dw ?     ; Fastest baud to use OPUS JANUS

         PRM_UserClass     db (12*type _uCLASS)  DUP(?)
         PRM_FosRegs       db (10*type _FOSREGS) DUP(?)

         PRM_F_Reward      dw ?
         PRM_last_area     dw ?
         PRM_last_farea    dw ?
         PRM_return_secure db ?
         PRM_xuflags       db ?
         PRM_xlmin         dw ?
         PRM_xlday         db ?
         PRM_expriv        db ?
         PRM_totlang       db ?
         PRM_sylno         db ?
         PRM_uslno         db ?
         PRM_fill3b        db ?
         PRM_Fill3         dw 13 DUP(?)

         PRM_MDM_Init      dw ?     ; modem initialization string
         PRM_MDM_PreDial   dw ?     ; modem dial command sent before number
         PRM_MDM_PostDial  dw ?     ; modem command sent after dialed number
         PRM_MDM_LookBusy  dw ?     ; mdm cmd to take modem off hook

                                    ;-------------------------------------------
                                    ; PRIMROSE PATHS
                                    ;-------------------------------------------
         PRM_misc_path     dw ?     ; path to BBS/GBS files
         PRM_sys_path      dw ?     ; path to SYSTEM?.BBS files
         PRM_temppath      dw ?     ; place to put temporary files
         PRM_net_info      dw ?     ; path to NODELIST files
         PRM_mailpath      dw ?     ; place to put received netmail bundles
         PRM_filepath      dw ?     ; place to put received netmail files
         PRM_hold_area     dw ?     ; path to pending outbound matrix traffic

                                    ;-------------------------------------------
                                    ; DATA FILE NAMES
                                    ;-------------------------------------------
         PRM_user_file     dw ?     ; path/filename of User.Bbs
         PRM_sched_name    dw ?     ; name of file with _sched array
         PRM_langdir       dw ?     ; default system language file
         PRM_spcldir       dw ?     ; default user language file

                                    ;-------------------------------------------
                                    ; MISCELLANEOUS TEXT
                                    ;-------------------------------------------
         PRM_system_name   dw ?     ; board's name
         PRM_sysop         dw ?     ; sysop's name
         PRM_timeformat    dw ?
         PRM_dateformat    dw ?
         PRM_protocols     dw 8 DUP(?)        ; external file protocol programs

                                    ;-------------------------------------------
                                    ; BBS/GBS SUPPORT FILES
                                    ;-------------------------------------------
         PRM_logo          dw ?     ; first file shown to a caller
         PRM_welcome       dw ?     ; shown after logon
         PRM_newuser1      dw ?
         PRM_newuser2      dw ?
         PRM_rookie        dw ?

         PRM_HLP_Editor    dw ?     ; Intro to msg editor for novices.
         PRM_HLP_Replace   dw ?     ; Explain the Msg.Editor E)dit command
         PRM_HLP_Inquire   dw ?     ; Explain the Msg. I)nquire command
         PRM_HLP_Locate    dw ?     ; Explain the Files L)ocate command
         PRM_HLP_Contents  dw ?     ; Explain the Files C)ontents command
         PRM_HLP_OPed      dw ?     ; help file for the full-screen editor
         PRM_OUT_Leaving   dw ?     ; Bon Voyage
         PRM_OUT_Return    dw ?     ; Welcome back from O)utside
         PRM_ERR_DayLimit  dw ?     ; Sorry, you've been on too long...
         PRM_ERR_TimeWarn  dw ?     ; warning about forced hangup
         PRM_ERR_TooSlow   dw ?     ; explains minimum logon baud rate
         PRM_ERR_XferBaud  dw ?     ; explains minimum file transfer baud rate
         PRM_LIST_MsgAreas dw ?     ; dump file... used instead of Dir.Bbs
         PRM_LIST_FileArea dw ?     ; dump file... used instead of Dir.Bbs
        
         PRM_FREQ_MyFiles  dw ?     ; file to send when FILES is file requested
         PRM_FREQ_OKList   dw ?     ; list of files approved for file requests
         PRM_FREQ_About    dw ?     ; File Request: ABOUT file

         PRM_OEC_Quotes    dw ?
         PRM_byebye        dw ?     ; file displayed at logoff
         PRM_local_editor  dw ?     ; text editor to use in keyboard mode
         PRM_barricade     dw ?

         PRM_Files_BBS     dw ?
         PRM_mailer        dw ?
         PRM_common        dw ?
         PRM_xdwarn        dw ?
         PRM_xtwarn        dw ?
         PRM_xdexpd        dw ?
         PRM_xtexpd        dw ?
         PRM_lang          dw 6 dup(?)
        

         PRM_OFSFILL       dw 3 DUP(?)

                                    ;-----------------------------------------------------------
                                    ; Log_Name must always be the last offset in this struct    
                                    ; because Bbs_Init uses that symbol to flag the end of      
                                    ; the offsets.                                              
                                    ;-----------------------------------------------------------
         PRM_log_name      dw ?     ; name of the log file


                                    ;-----------------------------------------------------------
                                    ; Big blob of stuff                                         
                                    ; It's a sequence of null-terminated character arrays...    
                                    ; pointed-to by the offsets (above).                        
                                    ;-----------------------------------------------------------
         PRM_BUF           db ?

_PRM     EndS

